package com.steerinfo.ems.foldthevalues.service.impl;

import com.steerinfo.ems.Utils.DateUtils;
import com.steerinfo.ems.emscalorificvalue.mapper.EmsCalorificValueMapper;
import com.steerinfo.ems.emscalorificvalue.model.EmsCalorificValue;
import com.steerinfo.ems.njformula.mapper.NjFormulaMapper;
import com.steerinfo.ems.njformula.model.NjFormula;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import com.steerinfo.ems.foldthevalues.model.FoldTheValues;
import com.steerinfo.ems.foldthevalues.mapper.FoldTheValuesMapper;
import com.steerinfo.ems.foldthevalues.service.IFoldTheValuesService;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import com.steerinfo.framework.service.pagehelper.PageList;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;
import java.text.DecimalFormat;
import java.util.Date;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * FoldTheValues服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-14 02:33
 * 类描述
 * 修订历史：
 * 日期：2021-10-14
 * 作者：generator
 * 参考：
 * 描述：FoldTheValues服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "foldTheValuesService")
public class FoldTheValuesServiceImpl extends BaseServiceImpl<FoldTheValues, String> implements IFoldTheValuesService {
    @Autowired
    private FoldTheValuesMapper foldTheValuesMapper;
    @Autowired
    private EmsCalorificValueMapper emsCalorificValueMapper;
    @Autowired
    private NjFormulaMapper njFormulaMapper;


    @Override
    protected IBaseMapper<FoldTheValues, String> getMapper() {
        return foldTheValuesMapper;
    }

    public void getDate() throws ScriptException {
        List<EmsCalorificValue> newDate = emsCalorificValueMapper.getNewDate();
        FoldTheValues foldTheValues = new FoldTheValues();
        for (EmsCalorificValue emsCalorificValue : newDate) {
            foldTheValues.setMaterialsource(emsCalorificValue.getMaterialsource());
            foldTheValues.setClock(emsCalorificValue.getSampleno());
            foldTheValues.setCode(this.getzbz(emsCalorificValue) == null ? "0.00" : this.getzbz(emsCalorificValue));
            foldTheValues.setMaterialno(emsCalorificValue.getMaterialno());
            foldTheValues.setIsavailable("0");
            foldTheValues.setUnitid("033");
            foldTheValues.setId(emsCalorificValue.getWtbh());
            foldTheValuesMapper.insert(foldTheValues);
        }
    }

    @Override
    public PageList<Map<String, Object>> getDateForPage(HashMap<String, Object> parmas, Integer pageNum, Integer pageSize) {
        PageHelper.startPage(pageNum,pageSize);
        List<Map<String, Object>> dateLc = foldTheValuesMapper.getDateForPage(parmas);
        PageList<Map<String, Object>> pageInfo = new PageList<Map<String, Object>>(dateLc);
        return pageInfo;
    }

    //获取折标值
    public String getzbz(EmsCalorificValue emsCalorificValue) throws ScriptException {
        ScriptEngine jse = new ScriptEngineManager().getEngineByName("JavaScript");
        //首先获取公式
        NjFormula njFormula = njFormulaMapper.getByMateralNo(emsCalorificValue.getMaterialno());
        String formula = njFormula.getCode();
        if (null == formula ){
            return  null;
        }
        HashMap map =  new HashMap();
        map.put("wtbh",emsCalorificValue.getWtbh());
        if(formula.contains("CO") == true){
            map.put("item","CO");
            String value = emsCalorificValueMapper.getValue(map) == null ? "0.00" : emsCalorificValueMapper.getValue(map);
            formula = formula.replace("CO", value);
        }
        if (formula.contains("H2") == true){
            map.put("item","H2");
            String value = emsCalorificValueMapper.getValue(map) == null ? "0.00" : emsCalorificValueMapper.getValue(map);
            formula = formula.replace("H2", value);
        }
        if (formula.contains("CH4") == true){
            map.put("item","CH4");
            String value = emsCalorificValueMapper.getValue(map) == null ? "0.00" : emsCalorificValueMapper.getValue(map);
            formula = formula.replace("CH4", value);
        }
        if (formula.contains("N2") == true){
            map.put("item","N2");
            String value = emsCalorificValueMapper.getValue(map) == null ? "0.00" :emsCalorificValueMapper.getValue(map);
            formula = formula.replace("N2", value);
        }
        DecimalFormat df   = new DecimalFormat("0.00");
        return  df.format(jse.eval(formula)).toString();
    }

}